package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.util.*;
import java.util.stream.*;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class COBTEST5_TX_KEY {
    public @Getter @Builder.Default String TX_CONT_NO = StringUtils.repeat(' ',
            13);
    public @Getter @Builder.Default String TX_IITEM = StringUtils
            .repeat(' ', 5);
    public @Getter @Builder.Default String TX_IITEM_GB = StringUtils.repeat(
            ' ', 2);

    public void setTX_CONT_NO(String source) {
        TX_CONT_NO = StringUtils.truncate(StringUtils.rightPad(source, 13), 13);
    }

    public void setTX_IITEM(String source) {
        TX_IITEM = StringUtils.truncate(StringUtils.rightPad(source, 5), 5);
    }

    public void setTX_IITEM_GB(String source) {
        TX_IITEM_GB = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public static COBTEST5_TX_KEY createDefaultValueInstance() {
        return new COBTEST5_TX_KEY.builder().build();
    }

    public void set(String source) {
        TX_CONT_NO = source.substring(0, 13);
        TX_IITEM = source.substring(13, 18);
        TX_IITEM_GB = source.substring(18, 20);
    }

    public void set(COBTEST5_DL_KEY source) {
        TX_CONT_NO = source.getDL_CONT_NO();
        TX_IITEM = source.getDL_IITEM();
        TX_IITEM_GB = source.getDL_IITEM_GB();
    }

    @Override
    public String toString() {
        return getTX_CONT_NO() + getTX_IITEM() + getTX_IITEM_GB();
    }
}
